package  {
	import flash.display.MovieClip;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.media.SoundMixer;
	
	public class AA extends MovieClip {
		//[Embed(source = 'audio/_track1.mp3')] public static var track1:Class;
		[Embed(source = 'sounds/bout.mp3')] public static var bout:Class;
		[Embed(source = 'sounds/bover.mp3')] public static var bover:Class;
		[Embed(source = 'sounds/click.mp3')] public static var click:Class;
		[Embed(source = 'sounds/hit.mp3')] public static var hit:Class;
		[Embed(source = 'sounds/jump1.mp3')] public static var jump1:Class;
		[Embed(source = 'sounds/jump2.mp3')] public static var jump2:Class;
		[Embed(source = 'sounds/jump3.mp3')] public static var jump3:Class;
		[Embed(source = 'sounds/kill.mp3')] public static var kill:Class;
		
		public static var arrJump:Array = new Array(jump1, jump2, jump3);
		
		public static var bAudio:Boolean = true;
		public static var bMusic:Boolean = true;
		
		public static var music:Sound = null;
		public static var musicTrans:SoundTransform = null;
		public static var musicChannel:SoundChannel = null;
		public static var musicVolume:Number = 0.0;
		
		public static var musicVolumeModifer:Number = 1.0;
		public static var mainTransform:SoundTransform = new SoundTransform(1, 0);
		public static var mutedTransform:SoundTransform = new SoundTransform(0, 0);
		
		public static var prevMusic:Class = null;
		
		public static function ChangeMusic(_sound:Class):void {
			if (prevMusic == _sound)
				return;
				
			if (musicChannel != null) {
				musicChannel.stop();
			}
			
			music = new _sound as Sound;
			musicVolume = 0.0;
			musicTrans = new SoundTransform(0.0, 0.0);
			musicChannel = music.play(0, int.MAX_VALUE, musicTrans);
			prevMusic = _sound;
		}
		
		public static function Play(_sound:Class, _volume:Number=1.0):void {
			var snd:Sound = new _sound;
			var trans:SoundTransform = new SoundTransform;
			trans.volume = _volume;
			snd.play(0, 0, trans);
		}
		
		public static function PlayRandom(_sounds:Array, _volume:Number=1.0):void {
			var snd:Sound = new (_sounds[Math.floor(Math.random() * _sounds.length)] as Class) as Sound;
			var trans:SoundTransform = new SoundTransform;
			trans.volume = _volume;
			snd.play(0, 0, trans);
		}
		
		public static function Tick(_dt:Number):void {
			if (musicChannel != null) {
				//trace(musicVolume);
				musicVolume = Misc.Clamp(musicVolume + _dt * 0.5, 0.0, 1.0);
				var newTransform:SoundTransform = new SoundTransform(musicVolume * musicVolumeModifer, 0);
				musicChannel.soundTransform = newTransform;
			}
		}
		
		public static function ToggleMusic(_active:Boolean):void {
			if (_active)
				musicVolumeModifer = 1.0;
			else
				musicVolumeModifer = 0.0;
			bMusic = _active;
		}
		
		public static function ToggleAll(_active:Boolean):void {
			if (_active)
				SoundMixer.soundTransform = mainTransform;
			else
				SoundMixer.soundTransform = mutedTransform;
			bAudio = _active;
		}
	}
}