package {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.Event;
	public class Actor extends MovieClip {
		var dead:Boolean = false;
		var layer:Sprite = null;
		
		// avoiding another Array!
		var container:Array = null;
		var container2:Array = null;
		var container3:Array = null;
		var container4:Array = null;
		
		var eventListeners:Array = new Array;
		var id:int = 0;
		var depthValue:Number = 0;
		var depthOffset:Number = 0;
		var health:Number = 0;
		
		public static var g:Game = null;
		
		public function Actor() {
			id = Misc.GetID();
			depthOffset = Misc.Random(-0.001, 0.001);
		}
		
		public function AddEventListener(_type:String, _func:Function) {
			g.addEventListener(_type, _func, false, 0, true);
			var obj:Object = new Object;
			obj.type = _type;
			obj.func = _func;
			eventListeners.push(obj);
		}
		
		public function AddToLayer(_layer:Sprite, _index:int = -1):void {
			if (layer && layer == _layer)
				return;
			if (layer)
				layer.removeChild(this);
			if (_index == -1)
				_layer.addChild(this);
			else
				_layer.addChildAt(this, _index);
			layer = _layer;
		}
		
		public function AddToContainer(_container:Array):void {
			if (!container) {
				container = _container;
				container.push(this);
			}
			else if (!container2) {
				container2 = _container;
				container2.push(this);
			}
			else if (!container3) {
				container3 = _container;
				container3.push(this);
			}
			else if (!container4) {
				container4 = _container;
				container4.push(this);
			}
			else {
				trace("warning! no more containers in Actor!");
			}
		}
		
		public function IsAlive():Boolean {
			return health > 0;
		}
		
		public function Kill():void {
			if (!dead) {
				dead = true;
				Misc.RemoveSpriteIfInside(this, layer);
				Misc.RemoveActor(this, container);
				Misc.RemoveActor(this, container2);
				Misc.RemoveActor(this, container3);
				Misc.RemoveActor(this, container4);
				visible = false;
				g.dispatchEvent(new GEvent(GEvent.ActorKilled, this));
				var i:int;
				for (i = 0; i < eventListeners.length; i++) {
					g.removeEventListener(eventListeners[i].type, eventListeners[i].func);
				}
			}
		}
	}
}






























