package  {
	import flash.events.MouseEvent;
	import flash.geom.Point;
	public class Crosshair extends Actor {
		var toggled:Boolean = false;
		var pos0:Point = new Point;
		var pos1:Point = new Point;
		var lerpT:Number = 0;
		var bdown:Boolean = false;
		var charge:Number = 0;
		var shootCharge:Number = 0;
		var isShooting:Boolean = false;
		
		public function Crosshair() {
			AddEventListener(GEvent.Tick, Tick);
			mouseEnabled = false;
			g.stage.addEventListener(MouseEvent.MOUSE_MOVE, MouseMove, false, 0, true);
			g.stage.addEventListener(MouseEvent.MOUSE_DOWN, MouseDown, false, 0, true);
			g.stage.addEventListener(MouseEvent.MOUSE_UP, MouseUp, false, 0, true);
			SetPosition( -100, -100);
			// !!!
			AddToLayer(g.layerUI);
		}
		
		public function MouseMove(e:MouseEvent):void {
			if (toggled) {
				x = e.stageX;
				y = e.stageY;
			}
		}
		
		public function MouseDown(e:MouseEvent):void {
			if (toggled) {
				bdown = true;
			}
		}
		
		public function MouseUp(e:MouseEvent):void {
			if (toggled) {
				bdown = false;
				shootCharge = charge;
				if (shootCharge > 0.1) {
					isShooting = true;
				}
				charge = 0;
			}
		}
		
		public function Toggle(_enable:Boolean):void {
			toggled = _enable;
		}
		
		public function SetPosition(_x:Number, _y:Number):void {
			pos0 = new Point(_x, _y);
			pos1 = new Point(_x, _y);
		}
		
		public function LerpTo(_x:Number, _y:Number):void {
			pos0.x = x;
			pos0.y = y;
			pos1.x = _x;
			pos1.y = _y;
			lerpT = 0;
		}
		
		public function CrosshairWorldLocation():Point {
			return g.layerLevel.localToGlobal(new Point(x, y));
		}
		
		public function Tick(e:GEvent):void {
			if (toggled) {
				if (bdown) {
					charge = Misc.Saturate(charge + T.dt * 0.8);
				}
			}
			else {
				lerpT = Misc.Saturate(lerpT + T.dt * 10.0);
				//trace(lerpT);
				x = Misc.Lerp(pos0.x, pos1.x, lerpT);
				y = Misc.Lerp(pos0.y, pos1.y, lerpT);
			}
			
			kProg.gotoAndStop(Math.floor(Misc.Lerp(1, 100, charge)));
			kProg.visible = charge > 0;
		}
	}
}
















