package  {
	import flash.geom.Point;
	public class Fry extends Actor {
		var pos0:Point = new Point;
		var pos1:Point = new Point;
		var lerpT:Number = 0;
		var prev_x:Number = 0;
		var prev_y:Number = 0;
		var frames:int = 0;
		var rot0:Number = 0;
		var rot1:Number = 0;
		var touched:Boolean = false;
		
		public function Fry() {
			AddToContainer(g.fries);
			AddToLayer(g.layerFries);
			AddEventListener(GEvent.Tick, Tick);
			visible = false;
		}
		
		public function SetPosition(_x:Number, _y:Number):void {
			pos0 = new Point(_x, _y);
			pos1 = new Point(_x, _y);
		}
		
		public function LerpTo(_x:Number, _y:Number, _rot:Number):void {
			pos0.x = x;
			pos0.y = y;
			pos1.x = _x;
			pos1.y = _y;
			
			rot0 = rotation;
			rot1 = Misc.ToDegrees(_rot);
			
			lerpT = 0;
			visible = true;
			Tick(null);
		}
		
		public function Tick(e:GEvent):void {
			if (touched) {
				gotoAndStop(2);
				alpha = Misc.Saturate(alpha -  T.dt);
				if (alpha < 0.5) {
					alpha = 0.5;
					Kill();
				}
				return;
			}
			
			//frames++;
			// avoid initial rotation bug
			//if (frames >= 2)
			//	visible = true;
			
			lerpT = Misc.Saturate(lerpT + T.dt * 10.0);
			
			prev_x = x;
			prev_y = y;
			x = Misc.Lerp(pos0.x, pos1.x, lerpT);
			y = Misc.Lerp(pos0.y, pos1.y, lerpT);
			
			rotation = Misc.Lerp(rot0, rot1, lerpT);
			
			/*
			var diffx:Number = x - prev_x;
			var diffy:Number = y - prev_y;
			if (diffx || diffy) {
				rotation = Misc.ToDegrees(Math.atan2(diffy, diffx));
			}
			*/
		}
	}
}