﻿package  {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import playerio.Client;
	import playerio.Connection;
	import playerio.DatabaseObject;
	import playerio.Message;
	import playerio.PlayerIO;
	import playerio.PlayerIOError;
	
	public class Game extends MovieClip {
		static var bLocalServer:Boolean = false;
		static var serverCode:String = compile error. go to playerio.com and create an account and game key!
		
		static var MaxPlayers:int			= 3;
		
		var layerLevel:Sprite = new Sprite;
		var layerEnemies:Sprite = new Sprite;
		var layerPenguin:Sprite = new Sprite;
		var layerFries:Sprite = new Sprite;
		var layerUI :Sprite = new Sprite;
		
		var layerLobby:Sprite = new Sprite;
		
		var time:Number = 0;
		var keys:Keys = null;
		var client:Client = null;
		var connection:Connection = null;
		
		var state:int = 0;
		public static const state_lobby:int			= 0;
		public static const state_combat:int			= 1;
		
		public function Game() {
			Actor.g = this;
			addEventListener(Event.ADDED_TO_STAGE, Added, false, 0, true);
		}
		
		public function Added(e:Event):void {
			addChild(layerLevel);
			addChild(layerEnemies);
			addChild(layerPenguin);
			addChild(layerFries);
			addChild(layerUI);
			addChild(layerLobby);
			
			kText.visible = false;
			keys = new Keys(stage);
			removeEventListener(Event.ADDED_TO_STAGE, Added, false);
			addEventListener(Event.ENTER_FRAME, Tick, false, 0, true);
			//GoToLobby();
			kGnomes.gotoAndStop(1);
			
			kLogin.kNameText.restrict = "A-Za-z0-9";
			kLogin.kPlay.gotoAndStop(1);
			kLogin.kPlay.buttonMode = true;
			kLogin.kPlay.addEventListener(MouseEvent.CLICK, ClickStart, false, 0, true);
			kLogin.kPlay.addEventListener(MouseEvent.ROLL_OVER, RollOver, false, 0, true);
			kLogin.kPlay.addEventListener(MouseEvent.ROLL_OUT, RollOut, false, 0, true);
		}
		
		public function RollOver(e:MouseEvent):void {
			AA.Play(AA.bover);
			kLogin.kPlay.gotoAndStop(2);
		}
		
		public function RollOut(e:MouseEvent):void {
			//AA.Play(AA.bout);
			kLogin.kPlay.gotoAndStop(1);
		}
		
		public function ClickStart(e:MouseEvent):void {
			//AA.PlayRandom(AA.arrJump);
			AA.Play(AA.click);
			kText.visible = true;
			kLogin.visible = false;
			GoToLobby();
		}
		
		public function GoToLobby():void {
			state = state_lobby;
			kText.text = "Connecting...";
			PlayerIO.connect(stage, serverCode, "public", "GuestUser" + Misc.RandomInt(1, 99999999), "", null, OnConnect);
		}
		
		public function OnConnect(_client:Client):void {
			kText.text = "Joining match making server...";
			client = _client;
			if (bLocalServer)
				client.multiplayer.developmentServer = "127.0.0.1:8184";
			client.multiplayer.createJoinRoom("lobbyroom", "Lobby", true, { }, { }, OnJoinRoom, OnError); // change Lobby to bounce to connect to any available room?
		}
		
		public function OnJoinRoom(_connection:Connection):void {
			kText.text = "Finding other players...";
			connection = _connection;
			connection.addMessageHandler("NetFoundOtherPlayers", NetFoundOtherPlayers);
		}
		
		public function OnError(_error:PlayerIOError):void {
			trace("OnError", _error);
			kText.text = "Connection error!\nPlease refresh your browser!";
		}
		
		//------------------------------------------------------------------------------------------
		
		public function NetFoundOtherPlayers(_m:Message, _roomName:String):void {
			trace("joining " + _roomName);
			kText.text = "Joining game...";
			connection.disconnect();
			client.multiplayer.createJoinRoom(_roomName, "Combat", false, { }, { }, OnJoinCombatRoom, OnError);
		}
		
		//------------------------------------------------------------------------------------------
		
		var combat:Boolean = false;
		var penguin:Penguin = null;
		var hud:Hud = null;
		var crosshair:Crosshair = null;
		var nextUpdate:Number = 0;
		var humans:Array = new Array;
		var enemies:Array = new Array;
		var stars:Array = new Array;
		var fries:Array = new Array;
		var myHuman:Human = null;
		
		// false
		public static const dev_allowAllControls:Boolean		= false;
		public static const dev_dumpLevelForServer:Boolean	= false;
		
		var playerType:int = 0;
		public static const playerType_strafe:int			= 0;
		public static const playerType_jump:int			= 1;
		public static const playerType_shoot:int			= 2;
		
		var keyLeft:Boolean = false;
		var keyRight:Boolean = false;
		var keySpacebar:Boolean = false;
		
		var level:Level = null;
		var currLevel:int = 0;
		
		public function OnJoinCombatRoom(_connection:Connection):void {
			state = state_combat;
			//kText.text = "Joined!";
			
			humans = new Array;
			LoadLevel(1);
			
			kTitle.visible = false;
			kText.visible = false;
			kGnomes.visible = false;
			removeChild(kGnomes); // !!!
			kTheme.visible = false;
			removeChild(kTheme); // !!!
			
			playerType = playerType_strafe;
			connection = _connection;
			connection.addMessageHandler("NetLeft", NetLeft);
			connection.addMessageHandler("NetName", NetName);
			connection.addMessageHandler("NetResetLevel", NetResetLevel);
			connection.addMessageHandler("NetSpawnStar", NetSpawnStar);
			connection.addMessageHandler("NetCollectedStar", NetCollectedStar);
			connection.addMessageHandler("NetUpdateEnemy", NetUpdateEnemy);
			connection.addMessageHandler("NetKilledEnemy", NetKilledEnemy);
			connection.addMessageHandler("NetUpdatePenguin", NetUpdatePenguin);
			connection.addMessageHandler("NetPenguinKilled", NetPenguinKilled);
			connection.addMessageHandler("NetAnnounceHuman", NetAnnounceHuman);
			connection.addMessageHandler("NetControls", NetControls);
			connection.addMessageHandler("NetDeadFry", NetDeadFry);
			connection.addMessageHandler("NetUpdateFry", NetUpdateFry);
			connection.addMessageHandler("NetPlaySound", NetPlaySound);
			
			hud = new Hud;
			crosshair = new Crosshair;
		}
		
		public function LoadLevel(_num:int):void {
			var i:int;
			if (enemies) {
				for (i = 0; i < enemies.length; i++) {
					enemies[i].Kill();
				}
			}
			if (stars) {
				for (i = 0; i < stars.length; i++) {
					stars[i].Kill();
				}
			}
			if (fries) {
				for (i = 0; i < fries.length; i++) {
					fries[i].Kill();
				}
			}
			
			enemies = new Array;
			stars = new Array;
			fries = new Array;
			
			currLevel = _num;
			if (level)
				level.GoToLevel(currLevel);
			else
				level = new Level(currLevel);
		}
		
		var nextNotify:Number = 0;
		public function Tick(e:Event):void {
			keys.Tick();
			time += T.dt;
			AA.Tick(T.dt);
			dispatchEvent(new GEvent(GEvent.Tick));
			
			if (state == state_lobby) {
				
			}
			else if (state == state_combat) {
				if (connection && connection.connected) {
					/*
					// notify every 500ms
					if (nextNotify < time) {
						nextNotify = time + 0.5;
						var i:int;
						for (i = 0; i < humans.length; i++) {
							if (humans[i].self)
								connection.send("notify", humans[i].id);
						}
					}
					*/
					
					if (keys.keyDown(Keys.key_left))
						keyLeft = true;
					if (keys.keyDown(Keys.key_right))
						keyRight = true;
					if (keys.keyDown(Keys.key_spacebar))
						keySpacebar = true;
					
					if (nextUpdate < time) {
						nextUpdate = time + 0.05;
						
						if (dev_allowAllControls || playerType == playerType_strafe) {
							if (connection.connected) {
								if (keyLeft)
									connection.send("movement", 1);
								else if (keyRight)
									connection.send("movement", 2);
								else
									connection.send("movement", 3);
							}
							keyLeft = false;
							keyRight = false;
						}
						
						if (dev_allowAllControls || playerType == playerType_jump) {
							if (connection.connected) {
								connection.send("spacebar", keySpacebar);
							}
							keySpacebar = false;
						}
						
						if (dev_allowAllControls || playerType == playerType_shoot) {
							var worldPos:Point = crosshair.CrosshairWorldLocation();
							var diff:Point = new Point;
							// not sure why using worldpos doesn't work correctly
							if (penguin) {
								diff.x = crosshair.x - penguin.x - layerLevel.x;
								diff.y = crosshair.y - penguin.y - layerLevel.y;
								//diff.x = worldPos.x - penguin.x;
								//diff.y = worldPos.y - penguin.y;
								var len:Number = diff.x * diff.x + diff.y * diff.y;
								if (len > 0.1) {
									len = Math.sqrt(len);
									diff.x /= len;
									diff.y /= len;
								}
							}
							if (connection.connected) {
								if (crosshair.isShooting)
									connection.send("crosshair", worldPos.x, worldPos.y, crosshair.bdown, crosshair.shootCharge, true, diff.x, diff.y);
								else
									connection.send("crosshair", worldPos.x, worldPos.y, crosshair.bdown, crosshair.charge, false, diff.x, diff.y);
							}
							crosshair.isShooting = false;
						}
					}
				}
				
				if (penguin) {
					// try to center the penguin
					var centerGlobal:Point = penguin.localToGlobal(new Point(0, 0));
					var desired:Point = new Point(T.width * 0.5, T.height * 0.7);
					var offx:Number = (desired.x - centerGlobal.x) * T.dt * 2;
					var offy:Number = (desired.y - centerGlobal.y) * T.dt * 2;
					layerLevel.x += offx;
					layerLevel.y += offy;
					layerEnemies.x = layerLevel.x;
					layerEnemies.y = layerLevel.y;
					layerPenguin.x = layerLevel.x;
					layerPenguin.y = layerLevel.y;
					layerFries.x = layerLevel.x;
					layerFries.y = layerLevel.y;
				}
			}
		}
		
		public function NetLeft(_m:Message, _id:int):void {
			var i:int;
			for (i = 0; i < humans.length; i++) {
				if (humans[i].id == _id) {
					//trace(_id + "," + humans[i].role);
					if (!hud.heads[humans[i].role].kDisc.visible) {
						hud.heads[humans[i].role].kDisc.visible = true;
						AA.Play(AA.bout); // changelater
					}
				}
			}
		}
		
		public function NetName(_m:Message, _id:int, _name:String):void {
			var i:int;
			for (i = 0; i < humans.length; i++) {
				if (humans[i].id == _id) {
					humans[i].name = _name;
				}
			}
			if (hud)
				hud.Refresh();
		}
		
		public function NetResetLevel(_m:Message, _num:int):void {			
			if (currLevel == _num) {
				if (penguin)
					penguin.gotoAndStop(1);
				var i:int;
				for (i = 0; i < stars.length; i++) {
					stars[i].visible = true;
				}
				/*
				for (i = 0; i < enemies.length; i++) {
					enemies[i].Revive();
				}
				*/
				// bugfix:
				if (enemies) {
					for (i = 0; i < enemies.length; i++) {
						enemies[i].Kill();
					}
				}
				enemies = new Array;
			}
			else {
				LoadLevel(_num);
			}
		}
		
		public function NetSpawnStar(_m:Message, _x:Number, _y:Number):void {
			new Star(_x, _y);
		}
		
		public function NetCollectedStar(_m:Message, _index:int):void {
			AA.Play(AA.click);
			if (stars.length > _index) {
				stars[_index].visible = false;
			}
		}
		
		public function NetUpdateEnemy(_m:Message, _x:Number, _y:Number, _type:int, _index:int):void {
			var enemy:Enemy;
			if (enemies.length <= _index) {
				enemy = new Enemy(_x, _y, _type);
			}
			else {
				enemy = enemies[_index];
				enemy.LerpTo(_x, _y);
			}
		}
		
		public function NetKilledEnemy(_m:Message, _index:int):void {
			var enemy:Enemy;
			if (enemies.length > _index) {
				enemy = enemies[_index];
				enemy.Die();
			}
		}
		
		public function NetUpdatePenguin(_m:Message, _x:Number, _y:Number):void {
			if (penguin) {
				penguin.LerpTo(_x, _y);
			}
			else {
				penguin = new Penguin;
				penguin.SetPosition(_x, _y);
			}
		}
		
		public function NetPenguinKilled(_m:Message):void {
			penguin.Die();
			AA.Play(AA.kill);
		}
		
		public function NetAnnounceHuman(_m:Message, _id:int, _myself:Boolean, _role:int):void {
			var human:Human= new Human;
			human.id = _id;
			human.self = _myself;
			human.role = _role;
			humans.push(human);
			if (_myself) {
				connection.send("MyNameIs", human.id, kLogin.kNameText.text);
				myHuman = human;
				playerType = human.role;
				if (playerType == playerType_shoot)
					crosshair.Toggle(true);
				else
					crosshair.Toggle(false);
				if (hud) {
					hud.heads[_role].kYou.visible = true;
				}
			}
		}
		
		var cont_left:Boolean = false;
		var cont_right:Boolean = false;
		var cont_space:Boolean = false;
		var cont_click:Boolean = false;
		var cont_mousex:Number = 0;
		var cont_mousey:Number = 0;
		var cont_charge:Number = 0;
		public function NetControls(_m:Message, _left:Boolean, _right:Boolean, _space:Boolean, _click:Boolean, _worldMousex:Number, _worldMousey:Number, _charge:Number):void {
			cont_left = _left;
			cont_right = _right;
			cont_space = _space;
			cont_click = _click;
			cont_charge = _charge;
			
			if (!crosshair.toggled) {
				var mouseLocal:Point = layerLevel.globalToLocal(new Point(_worldMousex, _worldMousey));
				cont_mousex = mouseLocal.x;
				cont_mousey = mouseLocal.y;
				crosshair.LerpTo(cont_mousex, cont_mousey);
				crosshair.charge = _charge;
			}
		}
		
		public function NetDeadFry(_m:Message, _id:int):void {
			var i:int;
			var fry:Fry = null;
			for (i = 0; i < fries.length; i++) {
				fry = fries[i];
				if (fry.id == _id) {
					fry.touched = true;
					fry.gotoAndStop(2);
					fry.SetPosition(fry.pos1.x, fry.pos1.y);
					return;
				}
			}
		}
		
		public function NetUpdateFry(_m:Message, _id:int, _x:Number, _y:Number, _rot:Number):void {
			var i:int;
			var fry:Fry = null;
			for (i = 0; i < fries.length; i++) {
				if (fries[i].id == _id) {
					fry = fries[i];
					break;
				}
			}
			if (fry) {
				fry.LerpTo(_x, _y, _rot);
			}
			else {
				fry = new Fry;
				fry.id = _id;
				fry.SetPosition(_x, _y);
			}
		}
		
		var nextPlayJump:Number = 0;
		public function NetPlaySound(_m:Message, _snd:int):void {
			// jump
			if (_snd == 0) {
				if (nextPlayJump < time) {
					AA.PlayRandom(AA.arrJump);
					nextPlayJump = time + 1.0;
				}
			}
			// die
			else if (_snd == 1) {
				AA.Play(AA.kill);
			}
			// hit
			else if (_snd == 2) {
				AA.Play(AA.hit);
			}
		}
	}
}







































