﻿package  {
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;

	public class Level extends Actor {
		public function Level(_frame:int) {
			if (Game.dev_dumpLevelForServer) {
				Dump();
			}
			GoToLevel(_frame);
			AddToLayer(g.layerLevel);
		}
		
		public function GoToLevel(_frame:int):void {
			gotoAndStop(_frame);
			var i:int;
			for (i = 0; i < numChildren; i++) {
				var mc:MovieClip = getChildAt(i) as MovieClip;
				if (mc) {
					var objClass:String = getQualifiedClassName(mc);
					if (objClass.search("Enemy") >= 0 && objClass.search("Collision") >= 0) {
						mc.visible = false;
					}
					else if (objClass.search("Star") >= 0) {
						mc.visible = false;
					}
				}
			}
		}
		
		public function Dump():void {
			var frame:int;
			var i:int;
			var j:int;
			
			for (frame = 1; frame <= totalFrames; frame++) {
				gotoAndStop(frame);
				var solids:Array = new Array;
				var enemies:Array = new Array;
				var stars:Array = new Array;
				
				for (i = 0; i < numChildren; i++) {
					var mc:MovieClip = getChildAt(i) as MovieClip;
					if (mc) {
						var objClass:String = getQualifiedClassName(mc);
						var data:Object = {};
						data.cellx = Math.round(mc.x);
						data.celly = Math.round(mc.y);
						// solids
						if (objClass.search("_Block") >= 0) {
							solids.push(data);
						}
						else if (objClass.search("_Enemy1") >= 0) {
							data.num = 1;
							enemies.push(data);
						}
						else if (objClass.search("_Enemy2") >= 0) {
							data.num = 2;
							enemies.push(data);
						}
						else if (objClass.search("Star") >= 0) {
							stars.push(data);
						}
					}
				}
				
				var line:String = "public int[] level" + currentFrame + " = {";
				for (i = 0; i < solids.length; i++) {
					if (i > 0)
						line += ",";
					line += solids[i].cellx + "," + solids[i].celly;
				}
				line += "};"
				trace(line);
				
				line = "public int[] level" + currentFrame + "Enemies = {";
				for (i = 0; i < enemies.length; i++) {
					if (i > 0)
						line += ",";
					line += enemies[i].cellx + "," + enemies[i].celly + "," + enemies[i].num;
				}
				line += "};"
				trace(line);
				
				line = "public int[] level" + currentFrame + "Stars = {";
				for (i = 0; i < stars.length; i++) {
					if (i > 0)
						line += ",";
					line += stars[i].cellx + "," + stars[i].celly;
				}
				line += "};"
				trace(line);
			}
		}
	}
}











































